// MplVcSmpDlg.cpp : implementation of the file
//
#include "windows.h"
#include "stdafx.h"
#include "MplVcSmp.h"
#include "MplVcSmpDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMplVcSmpDlg dialog

CMplVcSmpDlg::CMplVcSmpDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMplVcSmpDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMplVcSmpDlg)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMplVcSmpDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMplVcSmpDlg)
	DDX_Control(pDX, IDC_BUTTON_READEXTIN0, m_CButton_ReadExtIn0);
	DDX_Control(pDX, IDC_BUTTON_EXTOUT3, m_CButton_ExtOut3);
	DDX_Control(pDX, IDC_BUTTON_EXTOUT2, m_CButton_ExtOut2);
	DDX_Control(pDX, IDC_BUTTON_EXTOUT1, m_CButton_ExtOut1);
	DDX_Control(pDX, IDC_BUTTON_EXTOUT0, m_CButton_ExtOut0);
	DDX_Control(pDX, IDC_BUTTON_EXTLATCHCLR, m_CButton_ExtLatchClr);
	DDX_Control(pDX, IDC_BUTTON_OPENEXTIO, m_CButton_OpenExtIo);
	DDX_Control(pDX, IDC_BUTTON_CLOSEEXTIO, m_CButton_CloseExtIo);
	DDX_Control(pDX, IDC_BUTTON_CLRERR, m_CButton_Clrerr);
	DDX_Control(pDX, IDC_BUTTON_FASTSTOP, m_CButton_FastStop);
	DDX_Control(pDX, IDC_BUTTON_SLOWSTOP, m_CButton_SlowStop);
	DDX_Control(pDX, IDC_BUTTON_ENV, m_CButton_Env);
	DDX_Control(pDX, IDC_BUTTON_OPEN, m_CButton_Open);
	DDX_Control(pDX, IDC_BUTTON_CLOSE, m_CButton_Close);
	DDX_Control(pDX, IDOK, m_CButton_Ok);
	DDX_Control(pDX, IDC_BUTTON_RESET, m_CButton_Reset);
	DDX_Control(pDX, IDC_BUTTON_DATA_SET, m_CButton_DataSet);
	DDX_Control(pDX, IDC_BUTTON_CCW_SCAN, m_CButton_CCwScan);
	DDX_Control(pDX, IDC_BUTTON_CW_SCAN, m_CButton_CwScan);
	DDX_Control(pDX, IDC_BUTTON_ORG, m_CButton_Org);
	DDX_Control(pDX, IDC_BUTTON_RTN, m_CButton_Rtn);
	DDX_Control(pDX, IDC_BUTTON_CCW_INDEX, m_CButton_CCwIndex);
	DDX_Control(pDX, IDC_BUTTON_CW_INDEX, m_CButton_CwIndex);
	DDX_Control(pDX, IDC_BUTTON_DEMO, m_CButton_Demo);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMplVcSmpDlg, CDialog)
	//{{AFX_MSG_MAP(CMplVcSmpDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_OPEN, OnButtonOpen)
	ON_BN_CLICKED(IDC_BUTTON_CLOSE, OnButtonClose)
	ON_BN_CLICKED(IDC_BUTTON_RESET, OnButtonReset)
	ON_BN_CLICKED(IDC_BUTTON_DATA_SET, OnButtonDataSet)
	ON_BN_CLICKED(IDC_BUTTON_CCW_SCAN, OnButtonCCwScan)
	ON_BN_CLICKED(IDC_BUTTON_CW_SCAN, OnButtonCwScan)
	ON_BN_CLICKED(IDC_BUTTON_ORG, OnButtonOrg)
	ON_BN_CLICKED(IDC_BUTTON_RTN, OnButtonRtn)
	ON_BN_CLICKED(IDC_BUTTON_CCW_INDEX, OnButtonCCwIndex)
	ON_BN_CLICKED(IDC_BUTTON_CW_INDEX, OnButtonCwIndex)
	ON_BN_CLICKED(IDC_BUTTON_DEMO, OnButtonDemo)
	ON_BN_CLICKED(IDC_BUTTON_ENV, OnButtonEnv)
	ON_BN_CLICKED(IDC_BUTTON_CLRERR, OnButtonClrerr)
	ON_BN_CLICKED(IDC_BUTTON_FASTSTOP, OnButtonFaststop)
	ON_BN_CLICKED(IDC_BUTTON_SLOWSTOP, OnButtonSlowstop)
	ON_BN_CLICKED(IDC_BUTTON_OPENEXTIO, OnButtonOpenExtio)
	ON_BN_CLICKED(IDC_BUTTON_CLOSEEXTIO, OnButtonCloseExtio)
	ON_BN_CLICKED(IDC_BUTTON_EXTLATCHCLR, OnButtonExtlatchclr)
	ON_BN_CLICKED(IDC_BUTTON_EXTOUT0, OnButtonExtout0)
	ON_BN_CLICKED(IDC_BUTTON_EXTOUT1, OnButtonExtout1)
	ON_BN_CLICKED(IDC_BUTTON_EXTOUT2, OnButtonExtout2)
	ON_BN_CLICKED(IDC_BUTTON_EXTOUT3, OnButtonExtout3)
	ON_BN_CLICKED(IDC_BUTTON_READEXTIN0, OnButtonReadextin0)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMplVcSmpDlg message handler

BOOL CMplVcSmpDlg::OnInitDialog()
{
	CDialog::OnInitDialog( );

	// The icon for this dialog is set up. Frame work does not set up it automatically
	// when the main window of the application is not a dialog.
	SetIcon(m_hIcon, TRUE);			// Setting of a big icon
	SetIcon(m_hIcon, FALSE);		// Setting of a small icon

	m_CButton_Env.EnableWindow( TRUE );
	m_CButton_Open.EnableWindow( FALSE );
	m_CButton_Close.EnableWindow( FALSE );
	m_CButton_Ok.EnableWindow( TRUE );
	m_CButton_Reset.EnableWindow( FALSE );
	m_CButton_FastStop.EnableWindow( FALSE );
	m_CButton_SlowStop.EnableWindow( FALSE );
	m_CButton_DataSet.EnableWindow( FALSE );
	m_CButton_CCwScan.EnableWindow( FALSE );
	m_CButton_CwScan.EnableWindow( FALSE );
	m_CButton_Org.EnableWindow( FALSE );
	m_CButton_Rtn.EnableWindow( FALSE );
	m_CButton_CCwIndex.EnableWindow( FALSE );
	m_CButton_CwIndex.EnableWindow( FALSE );
	m_CButton_Demo.EnableWindow( FALSE );
	SetDlgItemText( IDC_LABEL_NOW_ADDRESS, "Please environmental setting." );

	m_CButton_OpenExtIo.EnableWindow( FALSE );
	m_CButton_CloseExtIo.EnableWindow( FALSE );
	m_CButton_ExtLatchClr.EnableWindow( FALSE );
	m_CButton_ExtOut0.EnableWindow( FALSE );
	m_CButton_ExtOut1.EnableWindow( FALSE );
	m_CButton_ExtOut2.EnableWindow( FALSE );
	m_CButton_ExtOut3.EnableWindow( FALSE );
	m_CButton_ReadExtIn0.EnableWindow( FALSE );

	return TRUE;
}

// If the minimization button is added to the dialog box, the code that draws the icon
// needs to be described below. Because the MFC application is using document/view model
// this processing is processed automatically by frame work.

void CMplVcSmpDlg::OnPaint()
{
	if( IsIconic( ) ){
		CPaintDC dc( this ); // Device context for drawing

		SendMessage( WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0 );

		// The center inside the rectangle range of the client
		int cxIcon = GetSystemMetrics( SM_CXICON );
		int cyIcon = GetSystemMetrics( SM_CYICON );
		CRect rect;
		GetClientRect( &rect );
		int x = ( rect.Width( ) - cxIcon + 1 ) / 2;
		int y = ( rect.Height( ) - cyIcon + 1 ) / 2;

		// Drawing the icon.
		dc.DrawIcon( x, y, m_hIcon );
	}
	else{
		CDialog::OnPaint( );
	}
}

// The system calls here to display the cursor while the user is doing the minimization window the drug.
HCURSOR CMplVcSmpDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//*******************************************************************************************************************
//
//
//   MPL-36-01v2.00/USBW32 VC++ Sample Program										5.4701.21.1311
//
//
//*******************************************************************************************************************
//
//

static DWORD hDev;												// Device Handle
static DWORD hUnit;												// Unit Handle
static DWORD hInPort;											// IN Port Handle
static DWORD hOutPort;											// OUT Port Handle

//*******************************************************************************************************************
//
//   The processing that the Environment Button was clicked.
//
//*******************************************************************************************************************
void CMplVcSmpDlg::OnButtonEnv() 
{
	MC07_S_RESULT		sResult;
	MC07_S_UNIT_INFO	unitInfo;
	CString				strNum;				//Message String1

	SetDlgItemText( IDC_LABEL_MESSAGE, "" );

	if (MC07_Environment(MC07_USB_UNIT_0, &sResult) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE, "It failed in MC07_Environment() : MC07_Result[1]=" + strNum);
		return;
	}

	if (MC07_ReadUnitInfo(MC07_USB_UNIT_0, &unitInfo, &sResult) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE, "It failed in MC07_ReadUnitInfo() : MC07_Result[1]=" + strNum );
		return;
	}

	if (unitInfo.UnitType[0] == 0xFF){
		SetDlgItemText( IDC_LABEL_MESSAGE, "NO CONTROLLER UNIT:Please Check USB connection" );
		return;
	}

	SetDlgItemText( IDC_LABEL_NOW_ADDRESS, "Please open the device." );
	m_CButton_Env.EnableWindow( FALSE );
	m_CButton_Ok.EnableWindow( TRUE );
	m_CButton_Open.EnableWindow( TRUE );
	m_CButton_Close.EnableWindow( FALSE );
	m_CButton_Reset.EnableWindow( FALSE );
	m_CButton_FastStop.EnableWindow( FALSE );
	m_CButton_SlowStop.EnableWindow( FALSE );
	m_CButton_DataSet.EnableWindow( FALSE );
	m_CButton_CCwScan.EnableWindow( FALSE );
	m_CButton_CwScan.EnableWindow( FALSE );
	m_CButton_Org.EnableWindow( FALSE );
	m_CButton_Rtn.EnableWindow( FALSE );
	m_CButton_CCwIndex.EnableWindow( FALSE );
	m_CButton_CwIndex.EnableWindow( FALSE );
	m_CButton_Demo.EnableWindow( FALSE );
	m_CButton_Clrerr.EnableWindow( FALSE );

	SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "Please Open Extend IO." );
	m_CButton_OpenExtIo.EnableWindow( TRUE );
	m_CButton_CloseExtIo.EnableWindow( FALSE );
	m_CButton_ExtLatchClr.EnableWindow( FALSE );
	m_CButton_ExtOut0.EnableWindow( FALSE );
	m_CButton_ExtOut1.EnableWindow( FALSE );
	m_CButton_ExtOut2.EnableWindow( FALSE );
	m_CButton_ExtOut3.EnableWindow( FALSE );
	m_CButton_ReadExtIn0.EnableWindow( FALSE );



}

//*******************************************************************************************************************
//
//   The processing that the Open Button was clicked.
//
//*******************************************************************************************************************
void CMplVcSmpDlg::OnButtonOpen()
{
	MC07_S_RESULT	sResult;
	CString				strNum;				//Message String1

	SetDlgItemText( IDC_LABEL_MESSAGE, "" );
	//*** DEVICE OPEN ***
	if (MC07_BOpen(MC07_USB_UNIT_0, MC07_X, &hDev, &sResult) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE, "It failed in MC07_BOpen() : MC07_Result[1]=" + strNum);
		m_CButton_Env.EnableWindow( TRUE );
		return;
	}
	m_CButton_Ok.EnableWindow( FALSE );
	m_CButton_Open.EnableWindow( FALSE );
	m_CButton_Close.EnableWindow( TRUE );
	m_CButton_Reset.EnableWindow( TRUE );
	m_CButton_FastStop.EnableWindow( TRUE );
	m_CButton_SlowStop.EnableWindow( TRUE );
	m_CButton_DataSet.EnableWindow( TRUE );
	m_CButton_CCwScan.EnableWindow( TRUE );
	m_CButton_CwScan.EnableWindow( TRUE );
	m_CButton_Org.EnableWindow( TRUE );
	m_CButton_Rtn.EnableWindow( TRUE );
	m_CButton_CCwIndex.EnableWindow( TRUE );
	m_CButton_CwIndex.EnableWindow( TRUE );
	m_CButton_Demo.EnableWindow( TRUE );
	m_CButton_Clrerr.EnableWindow( TRUE );
	NowAddressDisplay( hDev );
}

//*******************************************************************************************************************
//
//   The processing that the Close Button was clicked.
//
//*******************************************************************************************************************
void CMplVcSmpDlg::OnButtonClose()
{
	MC07_S_RESULT	sResult;
	CString				strNum;				//Message String1

	SetDlgItemText( IDC_LABEL_MESSAGE, "" );
	//*** DEVICE CLOSE ***
	if (MC07_BClose(hDev, &sResult) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE, "It failed in MC07_BClose() : MC07_Result[1]=" + strNum);
		m_CButton_Env.EnableWindow( TRUE );
		return;
	}
	m_CButton_Env.EnableWindow( TRUE );
	m_CButton_Ok.EnableWindow( TRUE );
	m_CButton_Open.EnableWindow( TRUE );
	m_CButton_Close.EnableWindow( FALSE );
	m_CButton_Reset.EnableWindow( FALSE );
	m_CButton_FastStop.EnableWindow( FALSE );
	m_CButton_SlowStop.EnableWindow( FALSE );
	m_CButton_DataSet.EnableWindow( FALSE );
	m_CButton_CCwScan.EnableWindow( FALSE );
	m_CButton_CwScan.EnableWindow( FALSE );
	m_CButton_Org.EnableWindow( FALSE );
	m_CButton_Rtn.EnableWindow( FALSE );
	m_CButton_CCwIndex.EnableWindow( FALSE );
	m_CButton_CwIndex.EnableWindow( FALSE );
	m_CButton_Demo.EnableWindow( FALSE );
	m_CButton_Clrerr.EnableWindow( FALSE );
	SetDlgItemText( IDC_LABEL_NOW_ADDRESS, "Please open the device." );
}

//*******************************************************************************************************************
//
//   The processing that the -Index Button was clicked.
//
//*******************************************************************************************************************
void CMplVcSmpDlg::OnButtonCCwIndex()
{
	MC07_S_RESULT	sResult;
	BYTE			StopCode;
	DWORD			LData;
	WORD			Cmd;
	CString				strNum;				//Message String1
	CString				strMessage;			//Message String2

	SetDlgItemText( IDC_LABEL_MESSAGE, "" );
	//*** INCREMENTAL INDEX DRIVE COMMAND ***
	if (CheckStatus1(hDev) == false) return;
	Cmd = 0x14;
	LData = MC07_Unsigned32(-3000);
	if (MC07_LWDrive(hDev, Cmd, &LData, &sResult) == false){
		strNum.Format(_T("%X"), Cmd);
		strMessage = "It failed in MC07_LWDrive(H'" + strNum + ") : MC07_Result[1]=";
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		strMessage += strNum;
		SetDlgItemText( IDC_LABEL_MESSAGE, strMessage);
		return;
	}
	ButtonDisable( );
	ReadyWait( hDev, &StopCode, FALSE );
    StopCodeDisplay( StopCode );
    ButtonEnable();

}

//*******************************************************************************************************************
//
//   The processing that the +Index Button was clicked.
//
//*******************************************************************************************************************
void CMplVcSmpDlg::OnButtonCwIndex()
{
	MC07_S_RESULT	sResult;
	BYTE			StopCode;
	DWORD			LData;
	WORD			Cmd;
	CString				strNum;				//Message String1
	CString				strMessage;			//Message String2

	SetDlgItemText( IDC_LABEL_MESSAGE, "" );
	//*** INCREMENTAL INDEX DRIVE COMMAND ***
	if (CheckStatus1(hDev) == false) return;
	Cmd = 0x14;
	LData = 3000;
	if (MC07_LWDrive(hDev, Cmd, &LData, &sResult) == false){
		strNum.Format(_T("%X"), Cmd);
		strMessage = "It failed in MC07_LWDrive(H'" + strNum + ") : MC07_Result[1]=";
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		strMessage += strNum;
		SetDlgItemText( IDC_LABEL_MESSAGE, strMessage);
		return;
	}
	ButtonDisable( );
	ReadyWait( hDev, &StopCode, FALSE );
    StopCodeDisplay( StopCode );
    ButtonEnable();

}

//*******************************************************************************************************************
//
//   The processing that the -Scan Button was clicked.
//
//*******************************************************************************************************************
void CMplVcSmpDlg::OnButtonCCwScan()
{
	MC07_S_RESULT	sResult;
	BYTE			StopCode;
	WORD			Cmd;
	CString				strNum;				//Message String1
	CString				strMessage;			//Message String2

	SetDlgItemText( IDC_LABEL_MESSAGE, "" );
	//*** -CCW SCAN DRIVE COMMAND ***
	if (CheckStatus1(hDev) == false) return;
	Cmd = 0x13;
	if (MC07_BWDriveCommand( hDev, &Cmd, &sResult ) == false){
		strNum.Format(_T("%X"), Cmd);
		strMessage = "It failed in MC07_BWDriveCommand(H'" + strNum + ") : MC07_Result[1]=";
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		strMessage += strNum;
		SetDlgItemText( IDC_LABEL_MESSAGE, strMessage);
		return;
	}
	ButtonDisable( );
	ReadyWait( hDev, &StopCode, FALSE );
    StopCodeDisplay( StopCode );
    ButtonEnable();
}

//*******************************************************************************************************************
//
//   The processing that the +Scan Button was clicked.
//
//*******************************************************************************************************************
void CMplVcSmpDlg::OnButtonCwScan()
{	
	MC07_S_RESULT	sResult;
	BYTE			StopCode;
	WORD			Cmd;
	CString				strNum;				//Message String1
	CString				strMessage;			//Message String2

	SetDlgItemText( IDC_LABEL_MESSAGE, "" );
	//*** +CW SCAN DRIVE COMMAND ***
	if (CheckStatus1(hDev) == false) return;
	Cmd = 0x12;
	if (MC07_BWDriveCommand( hDev, &Cmd, &sResult ) == false){
		strNum.Format(_T("%X"), Cmd);
		strMessage = "It failed in MC07_BWDriveCommand(H'" + strNum + ") : MC07_Result[1]=";
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		strMessage += strNum;
		SetDlgItemText( IDC_LABEL_MESSAGE, strMessage);
		return;
	}
	ButtonDisable( );
	ReadyWait( hDev, &StopCode, FALSE );
    StopCodeDisplay( StopCode );
    ButtonEnable();
}

//*******************************************************************************************************************
//
//   The processing that the Data Set Button was clicked.
//
//*******************************************************************************************************************
void CMplVcSmpDlg::OnButtonDataSet()
{
	MC07_S_RESULT	sResult;
	WORD			Data;
	WORD			Cmd;
	DWORD			LData;
	CString				strNum;				//Message String1
	CString				strMessage;			//Message String2

	SetDlgItemText( IDC_LABEL_MESSAGE, "" );


	//*** FSPD SET COMMAND       : 5000Hz ***
	if (CheckStatus1(hDev) == false) return;
	Cmd = 0x5;
	LData = 5000;
	if (MC07_LWDrive(hDev, Cmd, &LData, &sResult) == false){
		strNum.Format(_T("%X"), Cmd);
		strMessage = "It failed in MC07_LWDrive(H'" + strNum + ") : MC07_Result[1]=";
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		strMessage += strNum;
		SetDlgItemText( IDC_LABEL_MESSAGE, strMessage);
		return;
	}
	
	//*** JSPD SET COMMAND       : 1000Hz ***
	if (CheckStatus1(hDev) == false) return;
	Cmd = 0xC;
	LData = 1000;
	if (MC07_LWDrive(hDev, Cmd, &LData, &sResult) == false){
		strNum.Format(_T("%X"), Cmd);
		strMessage = "It failed in MC07_LWDrive(H'" + strNum + ") : MC07_Result[1]=";
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		strMessage += strNum;
		SetDlgItemText( IDC_LABEL_MESSAGE, strMessage);
		return;
	}
	
	//*** HIGH SPEED SET COMMAND ***
	if (CheckStatus1(hDev) == false) return;
	Data = 5000;                // HSPD       : 5000Hz;
	if (MC07_BWDriveData1( hDev, &Data, &sResult ) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE, "It failed in MC07_BWDriveData1(): MC07_Result[1]=" + strNum);
		return;
	}
	
	Data = 0x3;                 // RESOL No.  : 3;
	if (MC07_BWDriveData2( hDev, &Data, &sResult ) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE, "It failed in MC07_BWDriveData2(): MC07_Result[1]=" + strNum);
		return;
	}
	
	Cmd = 0x6;
	if (MC07_BWDriveCommand( hDev, &Cmd, &sResult ) == false){
		strNum.Format(_T("%X"), Cmd);
		strMessage = "It failed in MC07_BWDriveCommand(H'" + strNum + ") : MC07_Result[1]=";
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		strMessage += strNum;
		SetDlgItemText( IDC_LABEL_MESSAGE, strMessage);
		return;
	}
	
	//*** LOW SPEED SET COMMAND ***
	if (CheckStatus1(hDev) == false) return;
	Data = 1000;                // LSPD       : 1000Hz
	if (MC07_BWDriveData1( hDev, &Data, &sResult ) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE, "It failed in MC07_BWDriveData1(): MC07_Result[1]=" + strNum);
		return;
	}
	
	Data = 1000;                 // ELSPD      : 1000Hz
	if (MC07_BWDriveData2( hDev, &Data, &sResult ) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE, "It failed in MC07_BWDriveData2(): MC07_Result[1]=" + strNum);
		return;
	}
	
	Cmd = 0x7;
	if (MC07_BWDriveCommand( hDev, &Cmd, &sResult ) == false){
		strNum.Format(_T("%X"), Cmd);
		strMessage = "It failed in MC07_BWDriveCommand(H'" + strNum + ") : MC07_Result[1]=";
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		strMessage += strNum;
		SetDlgItemText( IDC_LABEL_MESSAGE, strMessage);
		return;
	}
	
	//*** RATE SET COMMAND ***
	if (CheckStatus1(hDev) == false) return;
	Data = 200;                // UCYCLE     : 100s
	if (MC07_BWDriveData1( hDev, &Data, &sResult ) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE, "It failed in MC07_BWDriveData1(): MC07_Result[1]=" + strNum);
		return;
	}
	
	Data = 200;                 // DCYCLE     : 100s
	if (MC07_BWDriveData2( hDev, &Data, &sResult ) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE, "It failed in MC07_BWDriveData2(): MC07_Result[1]=" + strNum);
		return;
	}
	
	Cmd = 0x8;
	if (MC07_BWDriveCommand( hDev, &Cmd, &sResult ) == false){
		strNum.Format(_T("%X"), Cmd);
		strMessage = "It failed in MC07_BWDriveCommand(H'" + strNum + ") : MC07_Result[1]=";
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		strMessage += strNum;
		SetDlgItemText( IDC_LABEL_MESSAGE, strMessage);
		return;
	}
	
	//*** ORIGIN SPEC SET ***
	if (CheckStatus1(hDev) == false) return;
	if (MC07_SetOrgSpec( hDev, 0x8000, &sResult ) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE, "It failed in MC07_SetOrgSpec(): MC07_Result[1]=" + strNum);
		return;
	}

	
	//*** MARGIN PULSE            : 5 Pulse ***
	if (CheckStatus1(hDev) == false) return;
	if (MC07_SetOrgMarginPulse( hDev, 5, &sResult ) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE, "It failed in MC07_SetOrgMarginPulse(): MC07_Result[1]=" + strNum);
		return;
	}
	

	SetDlgItemText( IDC_LABEL_MESSAGE, "DATA SET Succeed" );
}

//*******************************************************************************************************************
//
//   The processing that the Org Button was clicked.
//
//*******************************************************************************************************************
void CMplVcSmpDlg::OnButtonOrg()
{
	MC07_S_RESULT	sResult;
	BYTE			StopCode;
	CString				strNum;				//Message String1

	SetDlgItemText( IDC_LABEL_MESSAGE, "" );
	//*** ORIGIN DRIVE ***
	if (CheckStatus1(hDev) == false) return;
	if( MC07_Org( hDev, MC07_ORG3, &sResult ) ==false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE, "It failed in MC07_Org() : MC07_Result[1]=" + strNum);
		return;
	}
	ButtonDisable( );
	ReadyWait( hDev, &StopCode, TRUE );
    StopCodeDisplay( StopCode );
    ButtonEnable();
}

//*******************************************************************************************************************
//
//   The processing that the Reset Button was clicked.
//
//*******************************************************************************************************************
void CMplVcSmpDlg::OnButtonReset()
{
	MC07_S_RESULT	sResult;
	DWORD			LData;
	WORD			Cmd;
	CString				strNum;				//Message String1
	CString				strMessage;			//Message String2

	SetDlgItemText( IDC_LABEL_MESSAGE, "" );
	//*** ADDRESS COUNTER PRESET COMMAND ***
	Cmd = 0x80;
	LData = 0;
	if (MC07_LWDrive(hDev, Cmd, &LData, &sResult) == false){
		strNum.Format(_T("%X"), Cmd);
		strMessage = "It failed in MC07_LWDrive(H'" + strNum + ") : MC07_Result[1]=";
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		strMessage += strNum;
		SetDlgItemText( IDC_LABEL_MESSAGE, strMessage);
		return;
	}
	NowAddressDisplay( hDev );
}

//*******************************************************************************************************************
//
//   The processing that the Rtn Button was clicked.
//
//*******************************************************************************************************************
void CMplVcSmpDlg::OnButtonRtn()
{
	MC07_S_RESULT	sResult;
	BYTE			StopCode;
	DWORD			LData;
	WORD			Cmd;
	CString				strNum;				//Message String1
	CString				strMessage;			//Message String2

	SetDlgItemText( IDC_LABEL_MESSAGE, "" );
	//*** ABSOLUTE INDEX DRIVE COMMAND ***
	if (CheckStatus1(hDev) == false) return;
	Cmd = 0x15;
	LData = 0;
	if (MC07_LWDrive(hDev, Cmd, &LData, &sResult) == false){
		strNum.Format(_T("%X"), Cmd);
		strMessage = "It failed in MC07_LWDrive(H'" + strNum + ") : MC07_Result[1]=";
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		strMessage += strNum;
		SetDlgItemText( IDC_LABEL_MESSAGE, strMessage);
		return;
	}
	ButtonDisable( );
	ReadyWait( hDev, &StopCode, FALSE );
    StopCodeDisplay( StopCode );
    ButtonEnable();

}

//*******************************************************************************************************************
//
//   The processing that the Fast Stop Button was clicked.
//
//*******************************************************************************************************************
void CMplVcSmpDlg::OnButtonFaststop() 
{
	MC07_S_RESULT	sResult;
	WORD			Cmd;
	CString				strNum;				//Message String1
	CString				strMessage;			//Message String2

	//*** FAST STOP COMMAND ***
	Cmd = 0xFF;
	if (MC07_BWDriveCommand( hDev, &Cmd, &sResult ) == false){
		strNum.Format(_T("%X"), Cmd);
		strMessage = "It failed in MC07_BWDriveCommand(H'" + strNum + ") : MC07_Result[1]=";
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		strMessage += strNum;
		SetDlgItemText( IDC_LABEL_MESSAGE, strMessage);
		return;
	}	
}

//*******************************************************************************************************************
//
//   The processing that the Slow Stop Button was clicked.
//
//*******************************************************************************************************************
void CMplVcSmpDlg::OnButtonSlowstop() 
{
	MC07_S_RESULT	sResult;
	WORD			Cmd;
	CString				strNum;				//Message String1
	CString				strMessage;			//Message String2

	//*** SLOW STOP COMMAND ***
	Cmd = 0xFE;
	if (MC07_BWDriveCommand( hDev, &Cmd, &sResult ) == false){
		strNum.Format(_T("%X"), Cmd);
		strMessage = "It failed in MC07_BWDriveCommand(H'" + strNum + ") : MC07_Result[1]=";
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		strMessage += strNum;
		SetDlgItemText( IDC_LABEL_MESSAGE, strMessage);
		return;
	}	
}

//*******************************************************************************************************************
//
//   The processing that the Demo Button was clicked.
//
//*******************************************************************************************************************
void CMplVcSmpDlg::OnButtonDemo()
{

	WORD			Cmd;
	WORD			n;
	DWORD			LData;
	MC07_S_RESULT	sResult;
	BYTE			StopCode;
	CString				strNum;				//Message String1
	CString				strMessage;			//Message String2

	SetDlgItemText( IDC_LABEL_MESSAGE, "" );
	ButtonDisable( );

	//*** ORIGIN DRIVE ***
	if (CheckStatus1(hDev) == false){
		ButtonEnable( );
		return;
	}
	if( MC07_Org( hDev, MC07_ORG3, &sResult ) ==false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE, "It failed in MC07_Org() : MC07_Result[1]=" + strNum);
		ButtonEnable( );
		return;
	}
	ReadyWait( hDev, &StopCode, TRUE );
	if( StopCode != 0 ){
		StopCodeDisplay( StopCode );
		ButtonEnable( );
		return;
	}

	//*** ADDRESS COUNTER PRESET ***
	Cmd = 0x80;
	LData = 0;
	if (MC07_LWDrive(hDev, Cmd, &LData, &sResult) == false){
		strNum.Format(_T("%X"), Cmd);
		strMessage = "It failed in MC07_LWDrive(H'" + strNum + ") : MC07_Result[1]=";
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		strMessage += strNum;
		SetDlgItemText( IDC_LABEL_MESSAGE, strMessage);
		ButtonEnable( );
		return;
	}

	//*** INCREMENTAL INDEX DRIVE 4 Times ***
	for( n = 0 ; n < 4 ; n++ ){
		if (CheckStatus1(hDev) == false){
			ButtonEnable( );
			return;
		}
		Cmd = 0x14;
		LData = 4000;
		if (MC07_LWDrive(hDev, Cmd, &LData, &sResult) == false){
			strNum.Format(_T("%X"), Cmd);
			strMessage = "It failed in MC07_LWDrive(H'" + strNum + ") : MC07_Result[1]=";
			strNum.Format(_T("%d"), sResult.MC07_Result[1]);
			strMessage += strNum;
			SetDlgItemText( IDC_LABEL_MESSAGE, strMessage);
			ButtonEnable( );
			return;
		}
		ReadyWait( hDev, &StopCode, FALSE );
		if( StopCode != 0 ){
			StopCodeDisplay( StopCode );
			ButtonEnable( );
			return;
		}
	}

	//*** ABSOLUTE INDEX DRIVE ***
	if (CheckStatus1(hDev) == false){
		ButtonEnable( );
		return;
	}
	Cmd = 0x15;
	LData = 30000;
	if (MC07_LWDrive(hDev, Cmd, &LData, &sResult) == false){
		strNum.Format(_T("%X"), Cmd);
		strMessage = "It failed in MC07_LWDrive(H'" + strNum + ") : MC07_Result[1]=";
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		strMessage += strNum;
		SetDlgItemText( IDC_LABEL_MESSAGE, strMessage);
		ButtonEnable( );
		return;
	}
	ReadyWait( hDev, &StopCode, FALSE );
	if( StopCode != 0 ){
		StopCodeDisplay( StopCode );
		ButtonEnable( );
		return;
	}

	//*** ABSOLUTE INDEX DRIVE ***
	if (CheckStatus1(hDev) == false){
		ButtonEnable( );
		return;
	}
	Cmd = 0x15;
	LData = 0;
	if (MC07_LWDrive(hDev, Cmd, &LData, &sResult) == false){
		strNum.Format(_T("%X"), Cmd);
		strMessage = "It failed in MC07_LWDrive(H'" + strNum + ") : MC07_Result[1]=";
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		strMessage += strNum;
		SetDlgItemText( IDC_LABEL_MESSAGE, strMessage);
		ButtonEnable( );
		return;
	}
	ReadyWait( hDev, &StopCode, FALSE );
	StopCodeDisplay( StopCode );
	ButtonEnable( );
}

//********************************************************************************************************************
//
//   The processing that the Clear Error button was clicked.;
//
//********************************************************************************************************************
void CMplVcSmpDlg::OnButtonClrerr() 
{
	MC07_S_RESULT	sResult;
	CString				strNum;				//Message String1

	if (MC07_ClrError(hDev, &sResult) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE, "It failed in MC07_ClrError() : MC07_Result[1] = " + strNum);
		return;
	}
			
	SetDlgItemText( IDC_LABEL_MESSAGE, "MC07_ClrError() succeed");

}


//*******************************************************************************************************************
//
//   The processing that the End Button was clicked.
//
//*******************************************************************************************************************
void CMplVcSmpDlg::OnOK()
{
	CDialog::OnOK( );
}

//*******************************************************************************************************************
//
//   Setting the condition of the button in drive condition.
//
//*******************************************************************************************************************
void CMplVcSmpDlg::ButtonDisable( void )
{
	m_CButton_Close.EnableWindow( FALSE );
	m_CButton_Reset.EnableWindow( FALSE );
	m_CButton_DataSet.EnableWindow( FALSE );
	m_CButton_CCwScan.EnableWindow( FALSE );
	m_CButton_CwScan.EnableWindow( FALSE );
	m_CButton_Org.EnableWindow( FALSE );
	m_CButton_Rtn.EnableWindow( FALSE );
	m_CButton_CCwIndex.EnableWindow( FALSE );
	m_CButton_CwIndex.EnableWindow( FALSE );
	m_CButton_Demo.EnableWindow( FALSE );
	m_CButton_Clrerr.EnableWindow( FALSE );
}

//*******************************************************************************************************************
//
//   Setting the condition of the button in not drive condition.
//
//*******************************************************************************************************************
void CMplVcSmpDlg::ButtonEnable( void )
{
	m_CButton_Close.EnableWindow( TRUE );
	m_CButton_Reset.EnableWindow( TRUE );
	m_CButton_DataSet.EnableWindow( TRUE );
	m_CButton_CCwScan.EnableWindow( TRUE );
	m_CButton_CwScan.EnableWindow( TRUE );
	m_CButton_Org.EnableWindow( TRUE );
	m_CButton_Rtn.EnableWindow( TRUE );
	m_CButton_CCwIndex.EnableWindow( TRUE );
	m_CButton_CwIndex.EnableWindow( TRUE );
	m_CButton_Demo.EnableWindow( TRUE );
	m_CButton_Clrerr.EnableWindow( TRUE );
}

//*******************************************************************************************************************
//
//   Waits until MCC07 becomes ready condition. Meantime position address of motor is displayed.
//   Parameter hDevice          Device Handle
//             StopCode         Pointer of the variable where the drive stoppage factor is stored.
//                                 0:PASS  1:FSEND  2:SSEND  3:LSEND  4:SENSOR ERROR  5:ERROR PULSE ERROR  6:ADDRESS ERROR
//                                 7:FUNCTION ERROR;
//             OriginDriveFlag  The Flag is shown that ORIGIN DRIVE executing or other DRIVE executing.
//                                 True:ORIGIN DRIVE executing  False:other DRIVE executing
//
//*******************************************************************************************************************
UINT CMplVcSmpDlg::ReadyWait( DWORD hDevice, BYTE *StopCode, BOOL OriginDriveFlag )
{
	MSG				Message;
	MC07_S_RESULT	sResult;
	WORD			Status1;
	CString				strNum;				//Message String1
	CString				strMessage;			//Message String2

	do{
		while( PeekMessage( &Message, NULL, 0, 0, PM_REMOVE ) ){
			if ( Message.message == WM_QUIT ){
				return( Message.message );
			}
			TranslateMessage( &Message );
			DispatchMessage( &Message );
		}
		NowAddressDisplay( hDevice );
		if (MC07_BRStatus1( hDevice, &Status1, &sResult ) == false){
			strNum.Format(_T("%d"), sResult.MC07_Result[1]);
			SetDlgItemText( IDC_LABEL_MESSAGE, "It failed in MC07_BRStatus1(): MC07_Result[1]=" + strNum);
			*StopCode = 7;
			return( TRUE );
		}
	}while( Status1 & 0x0001 );

	NowAddressDisplay( hDevice );

    if( OriginDriveFlag ){
 		if (MC07_ReadOrgStatus( hDevice, &Status1, &sResult ) == false){
			strNum.Format(_T("%d"), sResult.MC07_Result[1]);
			SetDlgItemText( IDC_LABEL_MESSAGE, "It failed in MC07_ReadOrgStatus(): MC07_Result[1]=" + strNum);
			*StopCode = 7;
			return( TRUE );
		}
       if( Status1 & 0x8000 )
            *StopCode = 6;
        else if( Status1 & 0x4000 )
            *StopCode = 5;
        else if( Status1 & 0x2000 )
            *StopCode = 4;
        else if( Status1 & 0x0020 )
            *StopCode = 3;
        else if( Status1 & 0x0040 )
            *StopCode = 2;
        else if( Status1 & 0x0080 )
            *StopCode = 1;
		else
            *StopCode = 0;
		return( TRUE );
	}
	else{
        /*** Sets of the drive stoppage factor ***/
		if( Status1 & 0x0020 )
			*StopCode = 3;
		else if( Status1 & 0x0040 )
			*StopCode = 2;
		else if( Status1 & 0x0080 )
			*StopCode = 1;
		else
			*StopCode = 0;
		return( TRUE );
	}
}

//*******************************************************************************************************************
//
//   The stoppage factor of DRIVE that is shown with StopCode is displayed.
//   Parameters StopCode  The variable where the drive stoppage factor is stored.
//                           0:PASS  1:FSEND  2:SSEND  3:LSEND  4:SENSOR ERROR  5:ERROR PULSE ERROR  6:ADDRESS ERROR
//                           7:FUNCTION ERROR(NO MESSAGE);
//*******************************************************************************************************************
void CMplVcSmpDlg::StopCodeDisplay( BYTE StopCode )
{
	switch( StopCode ){
		case 1:
			SetDlgItemText( IDC_LABEL_MESSAGE, "FSSTOP was input." );
			break;

		case 2:
			SetDlgItemText( IDC_LABEL_MESSAGE, "SLSTOP was input." );
			break;

		case 3:
			SetDlgItemText( IDC_LABEL_MESSAGE, "LIMIT was input." );
			break;

        case 4:
            SetDlgItemText( IDC_LABEL_MESSAGE, "SENSOR ERROR was detected.\r\nPlease click 'Clear Error'" );
			break;

        case 5:
            SetDlgItemText( IDC_LABEL_MESSAGE, "ERROR PULSE ERROR was detected.\r\nPlease click 'Clear Error'" );
			break;

        case 6:
            SetDlgItemText( IDC_LABEL_MESSAGE, "ADDRESS ERROR was detected.\r\nPlease click 'Clear Error'" );
 			break;
       
		case 7:
			break;

		default:
			SetDlgItemText( IDC_LABEL_MESSAGE, "Drive ended." );
	}
}

//*******************************************************************************************************************
//
//   Position address of motor is displayed.
//   Parameter hDevice  Device Handle
//
//*******************************************************************************************************************
void CMplVcSmpDlg::NowAddressDisplay( DWORD hDevice )
{
	DWORD			WData;
	DWORD			RData;
	WORD			Cmd;
	MC07_S_RESULT	sResult;
	char			buf[20];
	CString				strNum;				//Message String1
	CString				strMessage;			//Message String2

	//*** ADDRESS COUNTER READ COMMAND ***
	Cmd = 0xD8;
	WData = 0;
	if (MC07_LWRDrive( hDevice, Cmd, &WData, &RData, &sResult ) == false){
		strNum.Format(_T("%X"), Cmd);
		strMessage = "It failed in MC07_LWRDrive(H'" + strNum + ") : MC07_Result[1]=";
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		strMessage += strNum;
		SetDlgItemText( IDC_LABEL_MESSAGE, strMessage);
		return;
	}	
	wsprintf( buf, "%ld", MC07_Signed32(RData) );
	SetDlgItemText( IDC_LABEL_NOW_ADDRESS, buf );
}


//********************************************************************************************************************
//
//   Check Status1 PORT.;
//   Parameter hDevice          Device Handle;
//   Return Value               TRUE: STATUS1 PORT BUSY BIT = 0 and ERROR BIT = 0;
//                                 FALSE: STATUS1 PORT BUSY BIT = 1 or ERROR BIT = 1;
//********************************************************************************************************************
BOOL CMplVcSmpDlg::CheckStatus1(DWORD hDevice)
{
	MC07_S_RESULT	sResult;
	WORD Cmd = 0;
	WORD Status1 = 0;
	WORD Data1 = 0;
	CString				strNum;				//Message String1
	CString				strMessage;			//Message String2

	//*** CHECK STATUS1 BUSY BIT = 0 (WAIT TIME = 1000ms)***
	if (MC07_BWaitDriveCommand(hDevice, 1000, &sResult) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE, "It failed in MC07_BWaitDriveCommand() : MC07_Result[1]=" + strNum);
		return false;
	}
			
	//*** READ STATUS1 ***
	if (MC07_BRStatus1(hDevice, &Status1, &sResult) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE, "It failed in MC07_BRStatus1() : MC07_Result[1]=" + strNum);
		return false;
	}
			
	//*** CHECK STATUS1 ERROR BIT = 0 ***
	if ( ( Status1 & 0x0010 ) != 0 ){
		//*** READ ERROR STATUS ***
		Cmd = 0xD1;
		if (MC07_BWDriveCommand(hDevice, &Cmd, &sResult) == false){
			strNum.Format(_T("%X"), Cmd);
			strMessage = "It failed in MC07_BWDriveCommand(H'" + strNum + ") : MC07_Result[1]=";
			strNum.Format(_T("%d"), sResult.MC07_Result[1]);
			strMessage += strNum;
			SetDlgItemText( IDC_LABEL_MESSAGE, strMessage);
			return false;
		}
			
		if (MC07_BRDriveData1(hDevice, &Data1, &sResult) == false){
			strNum.Format(_T("%d"), sResult.MC07_Result[1]);
			SetDlgItemText( IDC_LABEL_MESSAGE, "It failed in MC07_BRDriveData1() : MC07_Result[1]=" + strNum);
			return false;
		}
		
		strNum.Format(_T("%X"), Data1);
		SetDlgItemText( IDC_LABEL_MESSAGE, "STATUS1 ERROR = 1 : ERROR STATUS = H'" + strNum + "\r\nPlease click 'Clear Error'");			
		return false;
			
	}
			
	return true;

}




//********************************************************************************************************************
//
//   The processing that the Open Extend IO was clicked.;
//
//********************************************************************************************************************
void CMplVcSmpDlg::OnButtonOpenExtio() 
{
	MC07_S_RESULT	sResult;
	WORD extUnitStatus;
	WORD Data = 0;
	BOOL Ret;
	CString				strNum;				//Message String1

	SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "");
	//*** UNIT OPEN ***
	if (MC07_UOpen(MC07_USB_UNIT_0, &hUnit, &sResult) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "It failed in MC07_UOpen() : MC07_Result[1]=" + strNum);
		m_CButton_Env.EnableWindow( TRUE );
		return;
	}

	//*** UNIT COMMUNICATION MODE ***
   if (MC07_UWExUnitCommMode(hUnit, MC07_EX_UNIT_COMM_RATE_5, 3, MC07_EX_UNIT_COMM_16BIT, &sResult) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "It failed in MC07_UWExUnitCommMode() : MC07_Result[1]=" + strNum);
        //Because it is avoided double Unit Open Error
		Ret = MC07_UClose(hUnit,&sResult);
		m_CButton_Env.EnableWindow( TRUE );
		return;
	}

	//*** UNIT COMMUNICATION CONTROL ***
   if (MC07_UWExUnitCommControl(hUnit, MC07_EX_UNIT_COMM_START, &sResult) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "It failed in MC07_UWExUnitCommControl(START)  \r\n : MC07_Result[1]=" + strNum);
        //Because it is avoided double Unit Open Error
		Ret = MC07_UClose(hUnit,&sResult);
		m_CButton_Env.EnableWindow( TRUE );
		return;
	}

	//*** WAIT CONNECT BIT = 1 ***
	do{
		//*** READ UNIT COMMUNICATION STATUS ***
		if (MC07_URExUnitCommStatus(hUnit, &extUnitStatus, &sResult) == false){
			strNum.Format(_T("%d"), sResult.MC07_Result[1]);
			SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "It failed in MC07_URExUnitCommStatus() : MC07_Result[1]=" + strNum);
	        //Because it is avoided double Unit Open Error
			Ret = MC07_UClose(hUnit,&sResult);
			m_CButton_Env.EnableWindow( TRUE );
			return;
		}

		//*** CHECK POLLING BIT ***
		if ((extUnitStatus & 0x1) == 0){
			SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "EXTEND UNIT STATUS is not Polling. \r\nPlease Check EXTEND UNIT connection" );
	        //Because it is avoided double Unit Open Error
			Ret = MC07_UClose(hUnit,&sResult);
			return;
		}

		//*** CHECK DISCONNECT LATCH BIT ***
		if ((extUnitStatus & 0x4) !=0){
			SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "EXTEND UNIT STATUS is DISCONNECT LATCH. \r\n  Please Check EXTEND UNIT connection" );

			//*** UNIT COMMUNICATION CONTROL ***
			if (MC07_UWExUnitCommControl(hUnit, MC07_EX_UNIT_COMM_DISC_LATCH_CLR,&sResult) == false){
				strNum.Format(_T("%d"), sResult.MC07_Result[1]);
				SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "It failed in MC07_UWExUnitCommControl(LATCH_CLR)  \r\n : MC07_Result[1]=" + strNum);
		        //Because it is avoided double Unit Open Error
				Ret = MC07_UClose(hUnit,&sResult);
				m_CButton_Env.EnableWindow( TRUE );
				return;
			}
	        //Because it is avoided double Unit Open Error
			Ret = MC07_UClose(hUnit,&sResult);
			return;
		}
	//*** CHECK CONNECT BIT ***	
	}while( (extUnitStatus & 0x0002 ) == 0);


	//*** BPORT OPEN ***
	if (MC07_BPortOpen(MC07_USB_UNIT_0, MC07_EXP0_IN, &hInPort,&sResult) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "It failed in MC07_BPortOpen() : MC07_Result[1]=" + strNum);
        //Because it is avoided double Unit Open Error
		Ret = MC07_UClose(hUnit,&sResult);
		m_CButton_Env.EnableWindow( TRUE );
		return;
	}

	//*** BPORT OPEN ***
	if (MC07_BPortOpen(MC07_USB_UNIT_0, MC07_EXP0_OUT, &hOutPort,&sResult) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "It failed in MC07_BPortOpen() : MC07_Result[1]=" + strNum);
        //Because it is avoided double Unit Open Error and double BPort Open Error 
		Ret = MC07_UClose(hUnit,&sResult);
		Ret = MC07_BPortClose(hInPort,&sResult);
		m_CButton_Env.EnableWindow( TRUE );
		return;
	}
	//*** READ BPORT OUT ***
	if (MC07_BPortIn(hOutPort, &Data, &sResult) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "It failed in MC07_BPortIn() : MC07_Result[1]=" + strNum);
        //Because it is avoided double Unit Open Error and double BPort Open Error 
		Ret = MC07_UClose(hUnit,&sResult);
		Ret = MC07_BPortClose(hInPort,&sResult);
		Ret = MC07_BPortClose(hOutPort,&sResult);
		m_CButton_Env.EnableWindow( TRUE );
		return;
	}

	if ((Data & 0x1) != 0) SetDlgItemText( IDC_LABEL_EXTOUT0, "ON"); else SetDlgItemText( IDC_LABEL_EXTOUT0, "OFF");

	if ((Data & 0x2) != 0) SetDlgItemText( IDC_LABEL_EXTOUT1, "ON"); else SetDlgItemText( IDC_LABEL_EXTOUT1, "OFF");

	if ((Data & 0x4) != 0) SetDlgItemText( IDC_LABEL_EXTOUT2, "ON"); else SetDlgItemText( IDC_LABEL_EXTOUT2, "OFF");

	if ((Data & 0x8) != 0) SetDlgItemText( IDC_LABEL_EXTOUT3, "ON"); else SetDlgItemText( IDC_LABEL_EXTOUT3, "OFF");

	//*** READ BPORT IN ***//
	m_CButton_ReadExtIn0.EnableWindow( TRUE );
	OnButtonReadextin0();

	m_CButton_OpenExtIo.EnableWindow( FALSE );
	m_CButton_CloseExtIo.EnableWindow( TRUE );
	m_CButton_ExtLatchClr.EnableWindow( TRUE );
	m_CButton_ExtOut0.EnableWindow( TRUE );
	m_CButton_ExtOut1.EnableWindow( TRUE );
	m_CButton_ExtOut2.EnableWindow( TRUE );
	m_CButton_ExtOut3.EnableWindow( TRUE );
	
}

//********************************************************************************************************************
//
//   The processing that the Close Extend IO was clicked.;
//
//********************************************************************************************************************
void CMplVcSmpDlg::OnButtonCloseExtio() 
{
	MC07_S_RESULT	sResult;
	CString				strNum;				//Message String1
	
	//*** UNIT COMMUNICATION CONTROL ***
	if (MC07_UWExUnitCommControl(hUnit, MC07_EX_UNIT_COMM_STOP, &sResult) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "It failed in MC07_UWExUnitCommControl(STOP)  \r\n : MC07_Result[1]=" + strNum);
		m_CButton_Env.EnableWindow( TRUE );
		return;
	}
	
	//*** UNIT CLOSE ***
	if (MC07_UClose(hUnit, &sResult) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "It failed in MC07_UClose() : MC07_Result[1]=" + strNum);
		return;
	}
	
	//*** BPORT CLOSE ***
	if (MC07_BPortClose(hInPort, &sResult) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "It failed in MC07_BPortClose() : MC07_Result[1]=" + strNum);
		return;
	}
	
	//*** BPORT CLOSE ***
	if (MC07_BPortClose(hOutPort, &sResult) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "It failed in MC07_BPortClose() : MC07_Result[1]=" + strNum);
		return;
	}
	
	SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "");
	SetDlgItemText( IDC_LABEL_EXTOUT0, "");			SetDlgItemText( IDC_LABEL_EXTOUT1, "");
	SetDlgItemText( IDC_LABEL_EXTOUT2, "");			SetDlgItemText( IDC_LABEL_EXTOUT3, "");
	SetDlgItemText( IDC_LABEL_EXTIN0, "");			SetDlgItemText( IDC_LABEL_EXTIN1, "");
	SetDlgItemText( IDC_LABEL_EXTIN2, "");			SetDlgItemText( IDC_LABEL_EXTIN3, "");
	
	m_CButton_Env.EnableWindow( TRUE );
	m_CButton_OpenExtIo.EnableWindow( TRUE );
	m_CButton_CloseExtIo.EnableWindow( FALSE );
	m_CButton_ExtLatchClr.EnableWindow( FALSE );
	m_CButton_ExtOut0.EnableWindow( FALSE );
	m_CButton_ExtOut1.EnableWindow( FALSE );
	m_CButton_ExtOut2.EnableWindow( FALSE );
	m_CButton_ExtOut3.EnableWindow( FALSE );
	m_CButton_ReadExtIn0.EnableWindow( FALSE );
	
}

//********************************************************************************************************************
//
//   The processing that the Latch Clear was clicked.
//
//********************************************************************************************************************
void CMplVcSmpDlg::OnButtonExtlatchclr() 
{
	MC07_S_RESULT	sResult;
	CString				strNum;				//Message String1

	//*** UNIT COMMUNICATION CONTROL ***
	if (MC07_UWExUnitCommControl(hUnit, MC07_EX_UNIT_COMM_DISC_LATCH_CLR,  &sResult) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "It failed in MC07_UWExUnitCommControl(LATCH_CLR) \r\n : MC07_Result[1]=" + strNum);
		return;
	}
	
	SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "DISCONNECT LATCH CLEAR succeed");
	
}

//********************************************************************************************************************
//
//   The processing that the Extend Unit I/O OUT00 was clicked.;
//
//********************************************************************************************************************
void CMplVcSmpDlg::OnButtonExtout0() 
{
	MC07_S_RESULT	sResult;
	CString				strNum;				//Message String1
	WORD Data;
	
	SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "");
	
	//*** READ BPORT OUT ***
	if (MC07_BPortIn(hOutPort, &Data,  &sResult) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "It failed in MC07_BPortIn() : MC07_Result[1]=" + strNum);
		return;
	}
	
	if ((Data & 0x1) != 0){
		//ON -> OFF
		Data = 0xFFFF ^ 0x1;
		//*** BPORT AND OUT ***
		if (MC07_BPortAndOut(hOutPort,  &Data,  &sResult) == false){
			strNum.Format(_T("%d"), sResult.MC07_Result[1]);
			SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "It failed in MC07_BPortAndOut() : MC07_Result[1]=" + strNum);
			return;
		}
	
		//OFF -> ON
	}else{
		Data = 0x1;
		//*** BPORT OR OUT ***
		if (MC07_BPortOrOut(hOutPort,  &Data,  &sResult) == false){
			strNum.Format(_T("%d"), sResult.MC07_Result[1]);
			SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "It failed in MC07_BPortOrOut() : MC07_Result[1]=" + strNum);
			return;
		}
	}
	
	//*** CHECK UNIT I/O CONNECTINON *****
	if (CheckExtUnitStatus(hUnit) == false) return;
	
	//*** READ BPORT OUT ***
	if (MC07_BPortIn(hOutPort,  &Data,  &sResult) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "It failed in MC07_BPortIn() : MC07_Result[1]=" + strNum);
		return;
	}
	
	if ((Data & 0x1) != 0) SetDlgItemText( IDC_LABEL_EXTOUT0, "ON"); else SetDlgItemText( IDC_LABEL_EXTOUT0, "OFF");
	
}

//********************************************************************************************************************
//
//   The processing that the Extend Unit I/O OUT01 was clicked.;
//
//********************************************************************************************************************
void CMplVcSmpDlg::OnButtonExtout1() 
{
	MC07_S_RESULT	sResult;
	CString				strNum;				//Message String1
	WORD Data;
	
	SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "");
	
	//*** READ BPORT OUT ***
	if (MC07_BPortIn(hOutPort, &Data,  &sResult) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "It failed in MC07_BPortIn() : MC07_Result[1]=" + strNum);
		return;
	}
	
	if ((Data & 0x2) != 0){
		//ON -> OFF
		Data = 0xFFFF ^ 0x2;
		//*** BPORT AND OUT ***
		if (MC07_BPortAndOut(hOutPort,  &Data,  &sResult) == false){
			strNum.Format(_T("%d"), sResult.MC07_Result[1]);
			SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "It failed in MC07_BPortAndOut() : MC07_Result[1]=" + strNum);
			return;
		}
	
		//OFF -> ON
	}else{
		Data = 0x2;
		//*** BPORT OR OUT ***
		if (MC07_BPortOrOut(hOutPort,  &Data,  &sResult) == false){
			strNum.Format(_T("%d"), sResult.MC07_Result[1]);
			SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "It failed in MC07_BPortOrOut() : MC07_Result[1]=" + strNum);
			return;
		}
	}
	
	//*** CHECK UNIT I/O CONNECTINON *****
	if (CheckExtUnitStatus(hUnit) == false) return;
	
	//*** READ BPORT OUT ***
	if (MC07_BPortIn(hOutPort,  &Data,  &sResult) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "It failed in MC07_BPortIn() : MC07_Result[1]=" + strNum);
		return;
	}
	
	if ((Data & 0x2) != 0) SetDlgItemText( IDC_LABEL_EXTOUT1, "ON"); else SetDlgItemText( IDC_LABEL_EXTOUT1, "OFF");
	
}

//********************************************************************************************************************
//
//   The processing that the Extend Unit I/O OUT02 was clicked.;
//
//********************************************************************************************************************
void CMplVcSmpDlg::OnButtonExtout2() 
{
	MC07_S_RESULT	sResult;
	CString				strNum;				//Message String1
	WORD Data;
	
	SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "");
	
	//*** READ BPORT OUT ***
	if (MC07_BPortIn(hOutPort, &Data,  &sResult) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "It failed in MC07_BPortIn() : MC07_Result[1]=" + strNum);
		return;
	}
	
	if ((Data & 0x4) != 0){
		//ON -> OFF
		Data = 0xFFFF ^ 0x4;
		//*** BPORT AND OUT ***
		if (MC07_BPortAndOut(hOutPort,  &Data,  &sResult) == false){
			strNum.Format(_T("%d"), sResult.MC07_Result[1]);
			SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "It failed in MC07_BPortAndOut() : MC07_Result[1]=" + strNum);
			return;
		}
	
		//OFF -> ON
	}else{
		Data = 0x4;
		//*** BPORT OR OUT ***
		if (MC07_BPortOrOut(hOutPort,  &Data,  &sResult) == false){
			strNum.Format(_T("%d"), sResult.MC07_Result[1]);
			SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "It failed in MC07_BPortOrOut() : MC07_Result[1]=" + strNum);
			return;
		}
	}
	
	//*** CHECK UNIT I/O CONNECTINON *****
	if (CheckExtUnitStatus(hUnit) == false) return;
	
	//*** READ BPORT OUT ***
	if (MC07_BPortIn(hOutPort,  &Data,  &sResult) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "It failed in MC07_BPortIn() : MC07_Result[1]=" + strNum);
		return;
	}
	
	if ((Data & 0x4) != 0) SetDlgItemText( IDC_LABEL_EXTOUT2, "ON"); else SetDlgItemText( IDC_LABEL_EXTOUT2, "OFF");
	
	
}

//********************************************************************************************************************
//
//   The processing that the Extend Unit I/O OUT03 was clicked.;
//
//********************************************************************************************************************
void CMplVcSmpDlg::OnButtonExtout3() 
{
	MC07_S_RESULT	sResult;
	CString				strNum;				//Message String1
	WORD Data;
	
	SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "");
	
	//*** READ BPORT OUT ***
	if (MC07_BPortIn(hOutPort, &Data,  &sResult) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "It failed in MC07_BPortIn() : MC07_Result[1]=" + strNum);
		return;
	}
	
	if ((Data & 0x8) != 0){
		//ON -> OFF
		Data = 0xFFFF ^ 0x8;
		//*** BPORT AND OUT ***
		if (MC07_BPortAndOut(hOutPort,  &Data,  &sResult) == false){
			strNum.Format(_T("%d"), sResult.MC07_Result[1]);
			SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "It failed in MC07_BPortAndOut() : MC07_Result[1]=" + strNum);
			return;
		}
	
		//OFF -> ON
	}else{
		Data = 0x8;
		//*** BPORT OR OUT ***
		if (MC07_BPortOrOut(hOutPort,  &Data,  &sResult) == false){
			strNum.Format(_T("%d"), sResult.MC07_Result[1]);
			SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "It failed in MC07_BPortOrOut() : MC07_Result[1]=" + strNum);
			return;
		}
	}
	
	//*** CHECK UNIT I/O CONNECTINON *****
	if (CheckExtUnitStatus(hUnit) == false) return;
	
	//*** READ BPORT OUT ***
	if (MC07_BPortIn(hOutPort,  &Data,  &sResult) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "It failed in MC07_BPortIn() : MC07_Result[1]=" + strNum);
		return;
	}
	
	if ((Data & 0x8) != 0) SetDlgItemText( IDC_LABEL_EXTOUT3, "ON"); else SetDlgItemText( IDC_LABEL_EXTOUT3, "OFF");
	
	
}

//********************************************************************************************************************
//
//   The processing that the Read Extend Unit was clicked.;
//
//********************************************************************************************************************
void CMplVcSmpDlg::OnButtonReadextin0() 
{
	MC07_S_RESULT	sResult;
	CString				strNum;				//Message String1
	WORD Data = 0;

	SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "");
	//*** CHECK EXT UNIT I/O CONNECT *****
	if (CheckExtUnitStatus(hUnit) == false) return;

	//*** READ BPORT IN ***
	if (MC07_BPortIn(hInPort, &Data, &sResult) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "It failed in MC07_BPortIn() : MC07_Result[1]=" + strNum);
		return;
	}

	if ((Data & 0x1) != 0) SetDlgItemText( IDC_LABEL_EXTIN0, "ON"); else SetDlgItemText( IDC_LABEL_EXTIN0, "OFF");

	if ((Data & 0x2) != 0) SetDlgItemText( IDC_LABEL_EXTIN1, "ON"); else SetDlgItemText( IDC_LABEL_EXTIN1, "OFF");

    if ((Data & 0x4) != 0) SetDlgItemText( IDC_LABEL_EXTIN2, "ON"); else SetDlgItemText( IDC_LABEL_EXTIN2, "OFF");

	if ((Data & 0x8) != 0) SetDlgItemText( IDC_LABEL_EXTIN3, "ON"); else SetDlgItemText( IDC_LABEL_EXTIN3, "OFF");
	
}

//********************************************************************************************************************
//
//   Check ExtUnitStatus.;
//   Parameter UnitHandle          Unit Handle;
//   Return Value               TRUE: CONNECT BIT = 1 and DISCONNECT LATCH BIT = 0;
//                                 FALSE: CONNECT BIT = 0 or DISCONNECT LATCH BIT = 1;
//********************************************************************************************************************
BOOL CMplVcSmpDlg::CheckExtUnitStatus(DWORD UnitHandle)
{
	MC07_S_RESULT	sResult;
	CString				strNum;				//Message String1
	WORD extUnitStatus;

	//*** READ UNIT COMMUNICATION STATUS ***
	if (MC07_URExUnitCommStatus(UnitHandle, &extUnitStatus, &sResult) == false){
		strNum.Format(_T("%d"), sResult.MC07_Result[1]);
		SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "It failed in MC07_URExUnitCommStatus() : MC07_Result[1]=" + strNum);
		return false;
	}

	//*** CHECK CONNECT BIT ***
	if ((extUnitStatus & 0x2) == 0){
		SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "EXTEND UNIT STATUS is not Connected. \r\n  Please Check EXTEND UNIT connection" );
		return false;
	}

	//*** CHECK DISCONNECT LATCH BIT ***
	if ((extUnitStatus & 0x4 )!= 0){
		SetDlgItemText( IDC_LABEL_MESSAGE_EXTIO, "EXTEND UNIT STATUS is DISCONNECT LATCH. \r\n  Please Click 'Latch Clear' button" );
		return false;
	}

	return true;
}


